org.apache.fop.render.svg

## Class SVGPainter

- java.lang.Object
- - org.apache.fop.render.intermediate.AbstractIFPainter<AbstractSVGDocumentHandler>
  - - org.apache.fop.render.svg.SVGPainter

- All Implemented Interfaces:
    IFPainter, SVGConstants, XMLConstants

      public class SVGPainter
      extends AbstractIFPainter<AbstractSVGDocumentHandler>
      implements SVGConstants

  IFPainter implementation that writes SVG.

- - ### Field Summary

    - ### Fields inherited from class org.apache.fop.render.intermediate.AbstractIFPainter

      `INSTREAM_OBJECT_URI, state`

    - ### Fields inherited from interface org.apache.fop.render.svg.SVGConstants

      `FILE_EXTENSION_SVG, MIME_SVG_PRINT, MIME_TYPE, NAMESPACE, SVG_ELEMENT`

    - ### Fields inherited from interface org.apache.fop.util.XMLConstants

      `CDATA, XLINK_HREF, XLINK_NAMESPACE, XLINK_PREFIX, XML_NAMESPACE, XML_PREFIX, XML_SPACE, XMLNS_NAMESPACE_URI, XMLNS_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SVGPainter(AbstractSVGDocumentHandler parent, GenerationHelperContentHandler contentHandler)` Main constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clipBackground(java.awt.Rectangle rect, BorderProps bpsBefore, BorderProps bpsAfter, BorderProps bpsStart, BorderProps bpsEnd)` Restricts the current clipping region to the inner border.
    `void` | `clipRect(java.awt.Rectangle rect)` Restricts the current clipping region with the given rectangle.
    `protected RenderingContext` | `createRenderingContext()` Creates a new RenderingContext instance.
    `void` | `drawBorderRect(java.awt.Rectangle rect, BorderProps before, BorderProps after, BorderProps start, BorderProps end)`
    `void` | `drawImage(org.w3c.dom.Document doc, java.awt.Rectangle rect)` Draws an image (represented by a DOM document) inside a given rectangle.
    `void` | `drawImage(java.lang.String uri, java.awt.Rectangle rect)` Draws an image identified by a URI inside a given rectangle.
    `void` | `drawLine(java.awt.Point start, java.awt.Point end, int width, java.awt.Color color, RuleStyle style)` Draws a line.
    `void` | `drawText(int x, int y, int letterSpacing, int wordSpacing, int[][] dp, java.lang.String text)` Draws text.
    `void` | `endGroup()` Ends the current group and restores the previous coordinate system (and layer).
    `void` | `endViewport()` Ends the current viewport and restores the previous coordinate system.
    `void` | `fillBackground(java.awt.Rectangle rect, java.awt.Paint fill, BorderProps bpsBefore, BorderProps bpsAfter, BorderProps bpsStart, BorderProps bpsEnd)`
    `void` | `fillRect(java.awt.Rectangle rect, java.awt.Paint fill)` Fills a rectangular area.
    `void` | `handleExtensionObject(java.lang.Object extension)`
    `void` | `startGroup(java.awt.geom.AffineTransform[] transforms, java.lang.String layer)` Starts a new group of graphical elements.
    `void` | `startGroup(java.awt.geom.AffineTransform transform, java.lang.String layer)` Starts a new group of graphical elements.
    `void` | `startViewport(java.awt.geom.AffineTransform[] transforms, java.awt.Dimension size, java.awt.Rectangle clipRect)` Starts a new viewport, establishing a new coordinate system.
    `void` | `startViewport(java.awt.geom.AffineTransform transform, java.awt.Dimension size, java.awt.Rectangle clipRect)` Starts a new viewport, establishing a new coordinate system.

    - ### Methods inherited from class org.apache.fop.render.intermediate.AbstractIFPainter

      `createDefaultImageProcessingHints, drawBorderRect, drawImage, drawImage, drawImageUsingDocument, drawImageUsingImageHandler, drawImageUsingURI, getContext, getDocumentHandler, getFontInfo, getFontKey, getImageInfo, getLineBoundingBox, getUserAgent, hasOnlySolidBorders, isBackgroundRequired, setFont, toPoints`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SVGPainter

          public SVGPainter(AbstractSVGDocumentHandler parent,
                            GenerationHelperContentHandler contentHandler)

      Main constructor.
      Parameters:
        `parent` - the parent document handler
        `contentHandler` - the target SAX content handler

  - ### Method Detail

    - #### startViewport

          public void startViewport(java.awt.geom.AffineTransform transform,
                                    java.awt.Dimension size,
                                    java.awt.Rectangle clipRect)
                             throws IFException

      Starts a new viewport, establishing a new coordinate system. A viewport has a size and can optionally be clipped. Corresponds to SVG's svg element.
      Specified by:
        `startViewport` in interface `IFPainter`
      Parameters:
        `transform` - the transformation matrix establishing the new coordinate system
        `size` - the size of the viewport
        `clipRect` - the clipping rectangle (may be null)
      Throws:
        `IFException` - if an error occurs while handling this element

    - #### startViewport

          public void startViewport(java.awt.geom.AffineTransform[] transforms,
                                    java.awt.Dimension size,
                                    java.awt.Rectangle clipRect)
                             throws IFException

      Starts a new viewport, establishing a new coordinate system. A viewport has a size and can optionally be clipped. Corresponds to SVG's svg element.
      Specified by:
        `startViewport` in interface `IFPainter`
      Overrides:
        `startViewport` in class `AbstractIFPainter<AbstractSVGDocumentHandler>`
      Parameters:
        `transforms` - a series of transformation matrices establishing the new coordinate system
        `size` - the size of the viewport
        `clipRect` - the clipping rectangle (may be null)
      Throws:
        `IFException` - if an error occurs while handling this element

    - #### endViewport

          public void endViewport()
                           throws IFException

      Ends the current viewport and restores the previous coordinate system.
      Specified by:
        `endViewport` in interface `IFPainter`
      Throws:
        `IFException` - if an error occurs while handling this element

    - #### startGroup

          public void startGroup(java.awt.geom.AffineTransform[] transforms,
                                 java.lang.String layer)
                          throws IFException

      Starts a new group of graphical elements. Corresponds to SVG's g element.
      Specified by:
        `startGroup` in interface `IFPainter`
      Overrides:
        `startGroup` in class `AbstractIFPainter<AbstractSVGDocumentHandler>`
      Parameters:
        `transforms` - a series of transformation matrices establishing the new coordinate system
        `layer` - an optional layer label (or null if none)
      Throws:
        `IFException` - if an error occurs while handling this element

    - #### startGroup

          public void startGroup(java.awt.geom.AffineTransform transform,
                                 java.lang.String layer)
                          throws IFException

      Starts a new group of graphical elements. Corresponds to SVG's g element.
      Specified by:
        `startGroup` in interface `IFPainter`
      Parameters:
        `transform` - the transformation matrix establishing the new coordinate system
        `layer` - an optional layer label (or null if none)
      Throws:
        `IFException` - if an error occurs while handling this element

    - #### endGroup

          public void endGroup()
                        throws IFException

      Ends the current group and restores the previous coordinate system (and layer).
      Specified by:
        `endGroup` in interface `IFPainter`
      Throws:
        `IFException` - if an error occurs while handling this element

    - #### drawImage

          public void drawImage(java.lang.String uri,
                                java.awt.Rectangle rect)
                         throws IFException

      Draws an image identified by a URI inside a given rectangle. This is the equivalent to an fo:external-graphic in XSL-FO.
      Specified by:
        `drawImage` in interface `IFPainter`
      Parameters:
        `uri` - the image's URI
        `rect` - the rectangle in which the image shall be painted
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### drawImage

          public void drawImage(org.w3c.dom.Document doc,
                                java.awt.Rectangle rect)
                         throws IFException

      Draws an image (represented by a DOM document) inside a given rectangle. This is the equivalent to an fo:instream-foreign-object in XSL-FO.
      Specified by:
        `drawImage` in interface `IFPainter`
      Parameters:
        `doc` - the DOM document containing the foreign object
        `rect` - the rectangle in which the image shall be painted
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### createRenderingContext

          protected RenderingContext createRenderingContext()

      Creates a new RenderingContext instance.
      Specified by:
        `createRenderingContext` in class `AbstractIFPainter<AbstractSVGDocumentHandler>`
      Returns:
        the new rendering context.

    - #### clipRect

          public void clipRect(java.awt.Rectangle rect)
                        throws IFException

      Restricts the current clipping region with the given rectangle.
      Specified by:
        `clipRect` in interface `IFPainter`
      Parameters:
        `rect` - the rectangle's coordinates and extent
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### clipBackground

          public void clipBackground(java.awt.Rectangle rect,
                                     BorderProps bpsBefore,
                                     BorderProps bpsAfter,
                                     BorderProps bpsStart,
                                     BorderProps bpsEnd)
                              throws IFException

      Restricts the current clipping region to the inner border.
      Specified by:
        `clipBackground` in interface `IFPainter`
      Parameters:
        `rect` - the rectangle's coordinates and extent
        `bpsBefore` - the border segment on the before-side (top)
        `bpsAfter` - the border segment on the after-side (bottom)
        `bpsStart` - the border segment on the start-side (left)
        `bpsEnd` - the border segment on the end-side (right)
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### fillRect

          public void fillRect(java.awt.Rectangle rect,
                               java.awt.Paint fill)
                        throws IFException

      Fills a rectangular area.
      Specified by:
        `fillRect` in interface `IFPainter`
      Parameters:
        `rect` - the rectangle's coordinates and extent
        `fill` - the fill paint
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### drawBorderRect

          public void drawBorderRect(java.awt.Rectangle rect,
                                     BorderProps before,
                                     BorderProps after,
                                     BorderProps start,
                                     BorderProps end)
                              throws IFException

      Throws:
        `IFException`

    - #### drawLine

          public void drawLine(java.awt.Point start,
                               java.awt.Point end,
                               int width,
                               java.awt.Color color,
                               RuleStyle style)
                        throws IFException

      Draws a line. NOTE: Currently, only horizontal lines are implemented!
      Specified by:
        `drawLine` in interface `IFPainter`
      Overrides:
        `drawLine` in class `AbstractIFPainter<AbstractSVGDocumentHandler>`
      Parameters:
        `start` - the start point of the line
        `end` - the end point of the line
        `width` - the line width
        `color` - the line color
        `style` - the line style (using the Constants.EN_* constants for the rule-style property)
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### drawText

          public void drawText(int x,
                               int y,
                               int letterSpacing,
                               int wordSpacing,
                               int[][] dp,
                               java.lang.String text)
                        throws IFException

      Draws text. The initial coordinates (x and y) point to the starting point at the normal baseline of the font. The parameters letterSpacing, wordSpacing and the array dx are optional and can be used to influence character positioning (for example, for kerning).
      Specified by:
        `drawText` in interface `IFPainter`
      Parameters:
        `x` - X-coordinate of the starting point of the text
        `y` - Y-coordinate of the starting point of the text
        `letterSpacing` - additional spacing between characters (may be 0)
        `wordSpacing` - additional spacing between words (may be 0)
        `dp` - an array of 4-tuples, expressing [X,Y] placment adjustments and [X,Y] advancement adjustments, in that order (may be null); if not null, then adjustments.length must be the same as text.length()
        `text` - the text
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### handleExtensionObject

          public void handleExtensionObject(java.lang.Object extension)
                                     throws IFException

      Parameters:
        `extension` - an extension object
      Throws:
        `IFException` - if not caught

    - #### fillBackground

          public void fillBackground(java.awt.Rectangle rect,
                                     java.awt.Paint fill,
                                     BorderProps bpsBefore,
                                     BorderProps bpsAfter,
                                     BorderProps bpsStart,
                                     BorderProps bpsEnd)
                              throws IFException

      Throws:
        `IFException`

Copyright 1999-2015 The Apache Software Foundation. All Rights Reserved.